#include <hashmap.c>

////////////////////////////////
//////Custom Map Format/////////
////////////////////////////////

action pFunction(); 
MATERIAL* bump; 
MATERIAL* anim_Wind; 
var HOG_ON = 0;
HASHMAP* texture_Lib; 
var shadowTile = 0;
SOUND* custom_Envi;
SOUND* custom_Music;
var music_Handle;
var envi_Handle;

void play_Music(STRING* title, int tune){
	if(str_cmp(title,"-"))return;
	if(custom_Music != NULL)
	ptr_remove(custom_Music);
	custom_Music = snd_create(title);	
	music_Handle = snd_loop(custom_Music,tune,0);
	wait(1);
}

void play_EnviSound(STRING* title, int tune){
	if(str_cmp(title,"-"))return;
	if(custom_Envi != NULL)
	ptr_remove(custom_Envi);
	custom_Envi = snd_create(title);	
	envi_Handle = snd_loop(custom_Envi,tune,0);
	wait(1);
}
void initMapAttributes(var pan_, var roll_, var tilt_, var sun_, var s_R, var s_G, var s_B, var amb_, var a_R, var a_G, var a_B){
	sun_angle.pan = pan_;
	sun_angle.roll = roll_;
	sun_angle.tilt = tilt_;
	sun_light = sun_;
	sun_color.red = s_R;
	sun_color.green = s_G;
	sun_color.blue = s_B;
	camera.ambient = amb_;
	ambient_color.red = a_R;
	ambient_color.green = a_G;
	ambient_color.blue = a_B;

	return;
}

void getAction(STRING* abc){
	pFunction = engine_getscript(_chr(abc));
	wait_for(engine_getscript);
}

ENTITY* tempEntity;
BMAP* checkTexture_Lib(STRING* key){

	int f = 0;
	int i = 0;
	HASHMAP_NODE *node = NULL;
	while (hashmap_iterate(texture_Lib, &i, &node)){
		if (str_cmp(node->key,_chr(key)))
		{BMAP *a = hashmap_get(texture_Lib, _chr(key));	f = 1;return a;}
	}
	if(f == 0)
	{
		hashmap_insert(texture_Lib,bmap_create(_chr(key)), _chr(key));
		BMAP *a = hashmap_get(texture_Lib, _chr(key));	return a;
	}
	f = 0;

}
ENTITY* tempBlock;



void blockToStruct(STRING* picture_, var normalMap_, VECTOR* position_, var pan_, var tileType_, var tileZ_){

}

var loadTex = 0;
ENTITY* skyEntity;
function loadYMP(STRING* ymp_Name){
	
	if(texture_Lib != NULL)hashmap_free(texture_Lib); texture_Lib = hashmap_create();
	bump = mtl_create(); effect_load(bump,"bump.fx");
	anim_Wind = mtl_create(); effect_cpy(anim_Wind,mtl_animTree);

	var filehandle_n;
	var fileLength = 0;
	STRING* tempString = "#50";
	
	
	str_cpy(delimit_str,"<");

	STRING* skyScale_String = "#50";
	var skyScale_ = 0;
	STRING* skyPosition_String = "#50";
	var skyPosition_ = 0;
	STRING* skyPicture_String = "#50";
	STRING* noSky_String = "#50";
	STRING* mapDesignation_String = "#50";
	STRING* mapMusic_String = "#50";
	STRING* musicVolume_String = "#50";
	var musicVolume_ = 0;
	STRING* enviSound_String = "#50";
	STRING* enviVolume_String = "#50";
	var enviVolume_ = 0;
	STRING* encounterFrequency_String = "#50";
	var encounterFrequency_ = 0;
	STRING* encounter_On_String = "#50";
	STRING* sun_color_String = "#50";
	var sun_color_R = 0;
	var sun_color_G = 0;
	var sun_color_B = 0;
	STRING* ambientlight_String = "#50";
	var ambientlight_ = 0;
	STRING* ambient_color_String = "#50";
	var ambient_color_R = 0;
	var ambient_color_G = 0;
	var ambient_color_B = 0;
	STRING* sunlight_String = "#50";
	var sunlight_ = 0;
	STRING* sunlight_pan_String = "#50";
	var sunlight_pan_ = 0;
	STRING* sunlight_roll_String = "#50";
	var sunlight_roll_ = 0;
	STRING* sunlight_tilt_String = "#50";
	var sunlight_tilt_ = 0;
	STRING* fog_color_Name_String = "#50";
	
	STRING* fog_Begin_String = "#50";
	var fog_Begin_ = 0;
	STRING* fog_End_String = "#50";
	var fog_End_ = 0;
	STRING* fogcolor_String = "#50";
	VECTOR* fogcolor_ = nullvector;
	var sun_light_var = 0;

	if(str_cmp(ymp_Name,"") == 1){
	error("Please use level_load_ and a file designation to load a YMP.");	
	return;
	}
	filehandle_n = file_open_read (ymp_Name);	

if(filehandle_n == NULL) error("YMP Error - Can't find YMP.");
	fileLength = file_length (filehandle_n);

	file_find (filehandle_n,"<noSky>");
	file_str_read(filehandle_n, noSky_String);


	file_find (filehandle_n,"<scale_Sky>");
	file_str_read(filehandle_n,skyScale_String);
	skyScale_ = str_to_num(skyScale_String);

	file_find (filehandle_n,"<position_z_Sky>");
	file_str_read(filehandle_n, skyPosition_String);
	skyPosition_ = str_to_num(skyPosition_String);

	
	
	file_find (filehandle_n,"<mapDesignation>");
	file_str_read(filehandle_n, mapDesignation_String);

	file_find (filehandle_n,"<mapMusic>");
	file_str_read(filehandle_n, mapMusic_String);

	
	file_find (filehandle_n,"<musicVolume>");
	file_str_read(filehandle_n, musicVolume_String);
	musicVolume_ =	str_to_num(musicVolume_String);

	file_find (filehandle_n,"<enviSound>");
	file_str_read(filehandle_n, enviSound_String);

	file_find (filehandle_n,"<enviVolume>");
	file_str_read(filehandle_n, enviVolume_String);
	enviVolume_ = str_to_num(enviVolume_String);

	file_find (filehandle_n,"<encounterFrequency>");
	file_str_read(filehandle_n, encounterFrequency_String);
	encounterFrequency_ = str_to_num(encounterFrequency_String);
	
	file_find (filehandle_n,"<encounter_On>");
	file_str_read(filehandle_n, encounter_On_String);
	
	file_find (filehandle_n,"<skyTexture>");
	file_str_read(filehandle_n, skyPicture_String);
	
	file_find (filehandle_n,"<suncolor>");
	file_find (filehandle_n,"<x>");
	file_str_read(filehandle_n, sun_color_String);
	sun_color_R = str_to_num(sun_color_String);

	
	file_find (filehandle_n,"<y>");
	file_str_read(filehandle_n, sun_color_String);
	sun_color_G = str_to_num(sun_color_String);

	
	file_find (filehandle_n,"<z>");
	file_str_read(filehandle_n, sun_color_String);
	sun_color_B = str_to_num(sun_color_String);

	file_find (filehandle_n,"<ambientcolor>");
	file_find (filehandle_n,"<x>");
	file_str_read(filehandle_n, ambient_color_String);
	ambient_color_R = str_to_num(ambient_color_String);

	file_find (filehandle_n,"<y>");
	file_str_read(filehandle_n, ambient_color_String);
	ambient_color_G  = str_to_num(ambient_color_String);

	
	file_find (filehandle_n,"<z>");
	file_str_read(filehandle_n, ambient_color_String);
	ambient_color_B  = str_to_num(ambient_color_String);

	file_find (filehandle_n,"<sunlight>");
	file_str_read(filehandle_n, sunlight_String);
	sunlight_ = str_to_num(sunlight_String);

	file_find (filehandle_n,"<ambientlight>");
	file_str_read(filehandle_n, ambientlight_String);
	ambientlight_ = str_to_num(ambientlight_String);

	file_find (filehandle_n,"<sunlight_pan>");
	file_str_read(filehandle_n, sunlight_pan_String);
	sunlight_pan_ = str_to_num(sunlight_pan_String);

	file_find (filehandle_n,"<sunlight_roll>");
	file_str_read(filehandle_n, sunlight_roll_String);
	sunlight_roll_ = str_to_num(sunlight_roll_String);

	file_find (filehandle_n,"<sunlight_tilt>");
	file_str_read(filehandle_n, sunlight_tilt_String);
	sunlight_tilt_ = str_to_num(sunlight_tilt_String);

	file_find (filehandle_n,"<fog_Color>");
	file_str_read(filehandle_n, fog_color_Name_String);

	file_find (filehandle_n,"<fog_Begin>");
	file_str_read(filehandle_n, fog_Begin_String);
	fog_Begin_ = str_to_num(fog_Begin_);
	
	file_find (filehandle_n,"<fog_End>");
	file_str_read(filehandle_n, fog_End_String);
	fog_End_ = str_to_num(fog_End_String);
	
	file_find (filehandle_n,"<fogcolor>");
	file_find (filehandle_n,"<x>");
	file_str_read(filehandle_n, fogcolor_String);
	fogcolor_.x = str_to_num(fogcolor_String);
	
	file_find (filehandle_n,"<y>");
	file_str_read(filehandle_n, fogcolor_String);
	fogcolor_.y = str_to_num(fogcolor_String);
	
	file_find (filehandle_n,"<z>");
	file_str_read(filehandle_n, fogcolor_String);
	fogcolor_.z = str_to_num(fogcolor_String);
	
	if(str_len(skyPicture_String)> 0)
	{
		STRING* fSky = "\\Textures\\Skymap\\";
		str_cat(fSky,skyPicture_String);  
		BMAP* skyTexture = bmap_create(fSky);

		skyEntity = ent_create("\\Maps\\Templates\\EnviTube.mdl", vector(0, 0,skyPosition_),NULL);
		skyEntity.scale_x = skyScale_;
		skyEntity.scale_y = skyScale_;
		skyEntity.scale_z = skyScale_;
		ent_setskin(skyEntity,skyTexture,1); 
		if(skyEntity == NULL)error("Sky Map was not initialized.");
	}

	initMapAttributes(sunlight_pan_,sunlight_roll_,sunlight_tilt_,sunlight_,sun_color_R,sun_color_G,sun_color_B,ambientlight_,ambient_color_R,ambient_color_G,ambient_color_B);
	
	file_close(filehandle_n);
	filehandle_n = NULL;
	filehandle_n = file_open_read (ymp_Name);	
	fileLength = file_length (filehandle_n);
	
	

	
	while(file_find (filehandle_n,"<Editor_Tile>") > 0){

		STRING* picture_String ="#50";
		STRING* normalMap_String ="#50";
		STRING* position_X_String ="#50";
		STRING* position_Y_String ="#50";
		STRING* position_Z_String ="#50";
		STRING* pan_String ="#50";
		STRING* tileType_String ="#50";
		STRING* tileZ_String ="#50";

		STRING* picture_ = "#50";
		var normalMap_ = 0;
		VECTOR* position_ = nullvector;
		var pan_ = 0;
		var tileType_ = 0;
		var tileZ_ = 0;

		file_find (filehandle_n,"<picture>");
		file_str_read(filehandle_n, picture_String);
		str_cpy(picture_,picture_String);

		file_find (filehandle_n,"<normalMap>");
		file_str_read(filehandle_n, normalMap_String);
		if(str_cmp(normalMap_String,"true"))
		normalMap_ = 1;

		file_find (filehandle_n,"<position>");
		file_find (filehandle_n,"<x>");
		file_str_read(filehandle_n, position_X_String);
		position_.x = str_to_num(position_X_String);

		file_find (filehandle_n,"<y>");
		file_str_read(filehandle_n, position_Y_String);
		position_.y = str_to_num(position_Y_String);

		file_find (filehandle_n,"<z>");
		file_str_read(filehandle_n, position_Z_String);
		position_.z = str_to_num(position_Z_String);

		file_find (filehandle_n,"<tileType>");
		file_str_read(filehandle_n, tileType_String);
		tileType_ = str_to_num(tileType_String);

		file_find (filehandle_n,"<tileZ>");
		file_str_read(filehandle_n, tileZ_String);
		tileZ_ = str_to_num(tileZ_String);

		file_find (filehandle_n,"<pan>");
		file_str_read(filehandle_n, pan_String);
		pan_ = str_to_num(pan_String);



		shadowTile = 0;

		if(tileType_ == 1)
		{
			shadowTile = 1;
			tempBlock = ent_create("\\Maps\\Tiles\\Tile.mdl",position_,NULL);

		}
		else
		if(tileType_ == 2)
		{
			tempBlock = ent_create("\\Maps\\Tiles\\TileFlat.mdl",position_,NULL);

		}
		else
		if(tileType_ == 3)
		{
			shadowTile = 1;
			tempBlock = ent_create("\\Maps\\Tiles\\Cylinder.mdl",position_,NULL);

		}
		else
		if(tileType_ == 4)
		{
			tempBlock = ent_create("\\Maps\\Tiles\\FlatCylinder.mdl",position_,NULL);

		}
		else
		if(tileType_ == 5)
		{
			shadowTile = 1;
			tempBlock = ent_create("\\Maps\\Tiles\\Step.mdl",position_,NULL);

		}
		else
		if(tileType_ == 6)
		{
			tempBlock = ent_create("\\Maps\\Tiles\\StepFlat.mdl",position_,NULL);

		}
		else
		if(tileType_ == 7)
		{   
			shadowTile = 1;
			tempBlock = ent_create("\\Maps\\Tiles\\Obstacle.mdl",position_,NULL);
			
		}
		ent_cloneskin(tempBlock);
		ent_setskin(tempBlock,checkTexture_Lib(picture_),1);

		if(normalMap_ == 1)
		{
			STRING* tempString = str_create("");
			str_cpy(tempString,picture_);
			str_cpy(tempString,picture_);
			str_trunc(tempString,4);
			str_cat(tempString,"_n.png");
			
			loadTex++;
			
			ent_setskin(tempBlock,checkTexture_Lib(tempString),2);
			tempBlock.material = bump;	
		}
		tempBlock.x = position_.x;
		tempBlock.y = position_.y;
		tempBlock.z = position_.z;
		
		tempBlock.scale_z = tileZ_;
		tempBlock.pan = pan_;
		if(shadowTile == 1) set(tempBlock,SHADOW);
set(tempBlock,OVERLAY);

	}
	file_close(filehandle_n);
	filehandle_n = NULL;
	filehandle_n = file_open_read (ymp_Name);	
	fileLength = file_length (filehandle_n);
	file_find (filehandle_n,"<entityList>");
	while(file_find(filehandle_n,"<Editor_Entity>")> 0){


		STRING* model_String = "#50";
		STRING* lightRange_Active_String = "#50";
		STRING* selfColor_Active_String = "#50";
		STRING* lightStrength_String = "#50";
		var lightStrength = 0;
		STRING* lightRange_Value_String = "#50";
		var lightRange_Value_X = 0;
		var lightRange_Value_Y = 0;
		var lightRange_Value_Z = 0;
		STRING* position_String = "#50";
		var position_x = 0;
		var position_y = 0;
		var position_z = 0;
		STRING* pan_String = "#50";
		STRING* scale_String = "#50";
		var pan_ = 0;
		var scale_ = 0;
		var player_ = 0;
		STRING* overlay_String = "#50";
		STRING* passable_String = "#50";
		STRING* bright_String = "#50";
		STRING* translucent_String = "#50";
		STRING* shadow_String = "#50";
		STRING* unlit_String = "#50";
		STRING* gras_String = "#50";
		STRING* player_String = "#50";
		STRING* eventNumber = "#50";
		STRING* eventString = "#50";
		STRING* invisible_String = "#50";


		file_find (filehandle_n,"<model>");
		file_str_read(filehandle_n, model_String);

		file_find (filehandle_n,"<lightRange_Active>");
		file_str_read(filehandle_n, lightRange_Active_String);

		file_find (filehandle_n,"<selfColor_Active>");
		file_str_read(filehandle_n, selfColor_Active_String);

		file_find (filehandle_n,"<lightStrength>");
		file_str_read(filehandle_n, lightStrength_String);
		lightStrength = str_to_num(lightStrength_String);

		file_find (filehandle_n,"<lightRange_Value>");
		file_find (filehandle_n,"<x>");
		file_str_read(filehandle_n, lightRange_Value_String);
		lightRange_Value_X = str_to_num(lightRange_Value_String);

		file_find (filehandle_n,"<y>");
		file_str_read(filehandle_n, lightRange_Value_String);
		lightRange_Value_Y = str_to_num(lightRange_Value_String);

		file_find (filehandle_n,"<z>");
		file_str_read(filehandle_n, lightRange_Value_String);
		lightRange_Value_Z = str_to_num(lightRange_Value_String);

		file_find (filehandle_n,"<position>");
		file_find (filehandle_n,"<x>");
		file_str_read(filehandle_n, position_String);
		position_x = str_to_num(position_String);

		file_find (filehandle_n,"<y>");
		file_str_read(filehandle_n, position_String);
		position_y = str_to_num(position_String);

		file_find (filehandle_n,"<z>");
		file_str_read(filehandle_n, position_String);
		position_z = str_to_num(position_String);

		file_find (filehandle_n,"<pan>");
		file_str_read(filehandle_n, pan_String);
		pan_ = str_to_num(pan_String);
		file_find (filehandle_n,"<scale>");
		file_str_read(filehandle_n, scale_String);
		scale_ = str_to_num(scale_String);

		file_find (filehandle_n,"<flags>");
		file_find (filehandle_n,"<overlay>");
		file_str_read(filehandle_n, overlay_String);
		file_find (filehandle_n,"<passable>");
		file_str_read(filehandle_n, passable_String);
		file_find (filehandle_n,"<bright>");
		file_str_read(filehandle_n, bright_String);
		file_find (filehandle_n,"<translucent>");
		file_str_read(filehandle_n, translucent_String);
		file_find (filehandle_n,"<shadow>");
		file_str_read(filehandle_n, shadow_String);
		file_find (filehandle_n,"<unlit>");
		file_str_read(filehandle_n, unlit_String);
		file_find (filehandle_n,"<gras>");
		file_str_read(filehandle_n, gras_String);
		file_find (filehandle_n,"<player>");
		file_str_read(filehandle_n, player_String);
		file_find (filehandle_n,"<invisible>");
		file_str_read(filehandle_n, invisible_String);
		file_find (filehandle_n,"<event_>");
		file_str_read(filehandle_n, eventString);
	
			if(str_cmp(eventString,"NoAction"))
			tempEntity = ent_create(model_String,vector(position_x,position_y,position_z),NULL);
			else{
		getAction(eventString);
			tempEntity = ent_create(model_String,vector(position_x,position_y,position_z),pFunction);
		}

		if(str_cmp(selfColor_Active_String,"1") == 1)
		set(tempEntity,LIGHT);
		tempEntity.pan = pan_;
		tempEntity.scale_x = scale_;
		tempEntity.scale_y = scale_;
		tempEntity.scale_z = scale_;

		tempEntity.lightrange = lightStrength;
		tempEntity.red = lightRange_Value_X;
		tempEntity.green= lightRange_Value_Y;
		tempEntity.blue = lightRange_Value_Z;

	set(tempEntity,OVERLAY);	
		set(tempEntity,POLYGON);	
		if(str_cmp(overlay_String,"1") == 1)
		{
			set(tempEntity,OVERLAY);	
		}
		if(str_cmp(passable_String,"1") == 1)
		{	
			set(tempEntity,PASSABLE);
		}	
		if(str_cmp(bright_String,"1") == 1)
		{	
			set(tempEntity,BRIGHT);
		}	
		if(str_cmp(translucent_String,"1") == 1)
		{	
			set(tempEntity,TRANSLUCENT);
		}	
		if(str_cmp(shadow_String,"1") == 1)
		{
			set(tempEntity,SHADOW);
		}
		if(str_cmp(unlit_String,"1") == 1)
		{
			set(tempEntity,UNLIT);
		}	
		if(str_cmp(invisible_String,"1") == 1)
		{
			set(tempEntity,INVISIBLE);	
		}
		
	}


		play_Music(mapMusic_String,musicVolume_);
		wait_for(play_Music);		
	
		play_EnviSound(enviSound_String,enviVolume_);		
		wait_for(play_EnviSound);

	
}


void level_load_(STRING* designation){
	preload_mode = 4;
	level_load("EMPTY_MAP.WMB");
	wait_for(level_load);
	STRING* filePath = "#100";
	str_cpy(filePath,".\\Maps\\");
	str_cat(filePath,designation);
	loadYMP(filePath);
}
//////////////////////////////////////////////
//////////////////////////////////////////////
//////////////////////////////////////////////
